<?php

/**
 * adjuntos_declara_jura_novdet actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage adjuntos_declara_jura_novdet
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class adjuntos_declara_jura_novdetActions extends sfActions {

    /**
     * Executes list action
     * Se cambia por execute list, para filtro de periodo de retirados - 20150305
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");


        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.num_doc';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $id_contratista = $request['id_contratista'];
            $id_formato_pago = $request['id_formato_pago'];


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             */
            $sql = <<<EOD
select
act.adjuntos_novdet as adjuntos_novdet,
tab.*
from(

    select 
    aut.*,
    ROW_NUMBER() OVER (
      partition by aut.id_contratista
      ORDER BY aut.id_contratista, aut.fecha desc
    ) AS rn 
    
    from RVC_DECLARA_JURA_NOV aut
    
    where
    aut.firmado = 1
    and AUT.FECHA <= (select trunc(tab.fecha_log) from rvc_formato_pago tab where tab.id_formato_pago = $id_formato_pago)
    and AUT.ID_CONTRATISTA = $id_contratista

)tab

left join(
  select 
  det.ID_DECLARA_JURA_NOV,
  LISTAGG(det.adjunto, '@') WITHIN GROUP (ORDER BY det.ID_TIPO_PARENTEZCO DESC) as adjuntos_novdet
  from RVC_DECLARA_JURA_NOVDET det
  group by
  det.ID_DECLARA_JURA_NOV
)act
on act.ID_DECLARA_JURA_NOV = tab.ID_DECLARA_JURA_NOV

where
tab.rn = 1   
EOD;

            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);

            $this->totalRows = count($resultado);
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[adjuntos_declara_jura_novdet] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
